<?
/************************************************************************\
 * α׷ : oracle Ÿ̽ 
 * Ư   : 1.sqlplus scott/tiger@localhost @create_oracle.sql
  		2.Ʈ  ù(2004.03.10)
                3.Ѵ Խ(2004.06.17)
 * ̺ :
 * services   :
 *      : ö
 * ۼ   : 2001/08
 *      :
 *    :
 *    :
\************************************************************************/
require_once ('inc/common.php');

class db_oci8 extends db_common
{
  var $db_host=null;//ȣƮ
  var $db_user=null;//
  var $db_pass=null;//ȣ
  var $db_name=null;//Ÿ̽

  var $link=0;
  var $result=0;
  var $last_query=null;

  //Ÿ̽ ⺻
  function db_set($defconf)
  {
    if(empty($defconf))return;
$this->timestamps("db_set");
    $this->db_host=$defconf["oracle_host"];
    $this->db_user=$defconf["oracle_user"];
    $this->db_pass=$defconf["oracle_pass"];
    $this->db_name=$defconf["oracle_name"];
  }

  //Ȯ
  function _connected()
  {
    return $this->link;
  }

  //Ÿ̽ ýۿ ϱ
  function _connect_db()
  {
$this->timestamps("_connect_db");
    if(!$this->_connected()){
      $this->link = ocilogon($this->db_user,$this->db_pass,$this->db_host);
      if(empty($this->link))$this->_error_db();
    }//end if
    return $this->link;
  }

  // ϱ
  function _execute_query($query,$mode=OCI_DEFAULT)
  {
$this->timestamps("$query");

    $this->last_query=$query;

    if(!$this->_connected()) return false;

    //sql˻
    $this->stmt=ociparse($this->link,$query);
    if (!$this->stmt) return $this->_error_db();

    //sql
    //OCI_DEFAULT : Ź ø ڵ commit  ʵ .
    $this->result=ociexecute($this->stmt,$mode);
    if (!$this->result) return $this->_error_db();

    return $this->result;
  }

  //޽ ϱ
  function _error_db()
  {
    if( $error=ocierror($this->link) ){
      $query=wordwrap($this->last_query,80,"\n",1);

      echo "<div>\n";
      echo "<table width='100%' height='100%' border='0' cellpadding='0' cellspacing='0'>\n";
      echo "<tr>\n";
      echo "<td height=40 bgcolor='red' align='center' valign='middle'>\n";
      echo "<font color='#ffffff'><b>error</b></font></td></tr><tr>\n";
      echo "<td bgcolor='white'>\n";
      echo "sql query : <pre>". $query ."</pre><br>\n";
      echo "<p align=>". $error["message"] ."</p>\n";
      echo "</td>\n";
      echo "</tr><tr>\n";
      echo "<td height=40 bgcolor='red' align='center' valign='middle'>\n";
      echo "</td>\n";
      echo "</tr>\n";
      echo "</table>\n";
      echo "</div>\n";
      exit;
    }//endif
  }

  //clob 뷮 ؽƮ ϱ
  function _execute_clob($query,$text)
  {
    $this->last_query=$query;

    //sql˻
    $this->stmt=ociparse($this->link,$query);
    if (!$this->stmt) return $this->_error_db();

    $clob=ocinewdescriptor($this->link,OCI_D_LOB);
    ocibindbyname($this->stmt,":text",&$clob,-1,OCI_B_CLOB);

    //sql
    $this->result=ociexecute($this->stmt,OCI_DEFAULT);
    if (!$this->result) return $this->_error_db();

    if( $clob->save($text))ocicommit($this->link);
    else echo "problems:couldn't upload clob\n";

    //notice: ocifreedesc() should not be called like this.
    //use $clob->free() to free a lob in
    //ocifreedesc($clob);
    $clob->free();
  }

  //blob ̳ʸ  ϱ
  function _execute_blob($query,$filename)
  {
    $this->last_query=$query;

    //sql˻
    $this->stmt=ociparse($this->link,$query);
    if (!$this->stmt) return $this->_error_db();

    $blob=ocinewdescriptor($this->link,OCI_D_LOB);
    ocibindbyname($this->stmt,":file",&$blob,-1,OCI_B_BLOB);

    //sql
    $this->result=ociexecute($this->stmt,OCI_DEFAULT);
    if (!$this->result) return $this->_error_db();

    //ε ӽ Ѵ.
    if( !$fp=fopen($filename,"rb")) return;

    // Ϸκ о鿩 $buf  Ѵ.
    $buf=fread($fp,filesize($filename));

    //µ  ݴ´.
    fclose($fp);

    //blob о ̳ʸ  Ѵ.
    if($blob->save($buf))ocicommit($this->link);
    else echo "problems:couldn't upload blob\n";

    //notice: ocifreedesc() should not be called like this.
    //use $blob->free() to free a lob in
    //ocifreedesc($blob);
    $blob->free();
  }

  //clob(blob) Ÿ б
  function _execute_get($query,$fieldno)
  {
    $this->last_query=$query;

    //sql˻
    $this->stmt=ociparse($this->link,$query);
    if (!$this->stmt) return $this->_error_db();

    //sql
    $this->result=ociexecute($this->stmt);
    if (!$this->result) return $this->_error_db();

    //blob о̱  ocifetchinto ̿Ѵ.
    ocifetchinto($this->stmt,&$clob,OCI_ASSOC);

    return empty($clob) ? null:$clob[$fieldno]->load();
  }

  //Ÿ̽ 
  function _disconnect_db()
  {
$this->timestamps("_disconnect_db");
    ocirollback($this->link);
    ocilogoff($this->link);
  }

  function _version_db()
  {
    return ociserverversion($this->link);
  }

  function create_db($db)
  {
    global $sysconf;

    $filename=path_fix("$sysconf[path_inc]/create_oracle.sql");
    $common_query=file_get_contents($filename);

    $common_query=ereg_replace("<database>",$this->db_name,chop($common_query));
    $common_query=ereg_replace("<table_name>",$db,chop($common_query));

    $this->_connect_db();
    $this->_execute_query($common_query);
    $this->_disconnect_db();
  }

  function drop_db($db)
  {
    return $this->_execute_query("drop table ${db}");
  }
/************************************************************************\
[].ε б
\************************************************************************/
  //ü Ÿ б
  function loadtotal($db,$ff='',$fw='')
  {
    switch($ff)
    {
      case 'content':
      case 'all':
        //intermedia option ġ()
        //oracle long ڷ ˻ϱ
        //ó http://database.sarang.net  long ˻ ϴٰ ؼ
        //Ʒ  Ʈ  ߴµ...
        $common_query="select count(rowid) as cnt from $db where contains(content,'%$fw%')>0";
        break;

      default:
        $common_query="select count(rowid) as cnt from $db where $ff like '%$fw%'";
        break;
    }//end switch

    if( empty($ff)||empty($fw))
    $common_query="select count(rowid) as cnt from $db";

    //ͺ̽ 
    $this->_connect_db();

    //sql
    $this->_execute_query($common_query);
    ocifetchinto($this->stmt,$row,OCI_ASSOC);
    $total=$row["CNT"];

    //ͺ̽ 
    $this->_disconnect_db();

    return $total;
  }
  //ü ε б
  function loadindexfile($db,$total=0,$page=1,$limit=15)
  {
    return $this->findindexfile($db,'','',$total,$page,$limit);
  }
  //˻ ε б
  function findindexfile($db,$ff='',$fw='',$total=0,$page=1,$limit=15)
  {
    switch($ff)
    {
      case 'content':
      case 'all':
        $f_query="and contains(content,'%$fw%')>0";
        break;

      default:
        $f_query="and $ff like '%$fw%'";
        break;
    }//end switch

    if( empty($ff)||empty($fw)) $f_query="";

    //ͺ̽ 
    $this->_connect_db();

    // (ù°=1,ǳ=üǼ)
    $start_offset=max(($page-1)*$limit,1);
    $end_offset=min($page*$limit,$total);
    $offset_query="select ppid from (select --+index_desc({$db},{$db}_idx_02)\n".
                  "ppid,rownum rnum from {$db} where ppid>0 $f_query)\n".
                  "where rnum>=$start_offset and rownum <= $limit";

    // ü    յİ˻
    if($start_offset > ($total/2)) $flag=1; else  $flag=0;

    //̻
    if($flag){
    $end_offset=max($total-$end_offset,0);
    $offset_query="select ppid from (select --+index({$db},{$db}_idx_02)\n".
                  "ppid,rownum rnum from {$db} where ppid>0 $f_query)\n".
                  "where rnum>=$end_offset and rownum <= $limit";
    }//end if

    $this->_execute_query($offset_query);
    while(ocifetchinto($this->stmt,$row,OCI_ASSOC))
    $offset[]=$row["PPID"];

    //,
    $start_ppid=min($offset);
    $end_ppid=max($offset);

    //  Ÿ
    $count_query="select count(ppid) as cnt from $db where ppid > $end_ppid $f_query";
    if($flag)$count_query="select count(ppid) as cnt from {$db} where ppid <= $end_ppid $f_query";

    //sql
    $this->_execute_query($count_query);
    ocifetchinto($this->stmt,$row,OCI_ASSOC);
    $count=$row["CNT"];

    if($flag)$count=max($total-$count,0);

    //sql
    $common_query="select --+use_nl({$db},{$db}_idx_02)\n".
    		  "id,pid,ppid from $db\n".
                  "where ppid >= $start_ppid and ppid <= $end_ppid $f_query";

    //sql
    $index=array();
    $this->_execute_query($common_query);
    while(ocifetchinto($this->stmt,$row,OCI_ASSOC))
    $index[]=array_change_key_case($row);

    //ͺ̽ 
    $this->_disconnect_db();

    //Ʈ  ù(2004.03.10)
    $index=index_chain('id','pid','ppid',$index);

    //  Ÿ ϱ
    if($start_offset>1)
    array_splice($index,0,$start_offset - $count);

    return $index;
  }

  // ε б
  function sortindexfile($db,$ff){}

  //亯 ε б(2002.03.12)
  function findreplyfile($db,$ppid)
  {
    //ӽ
    if( ($ppid)<1 ) return null;

    //sql
    $common_query="select id,pid,ppid from $db where ppid=$ppid";

    //ͺ̽ 
    $this->_connect_db();

    //sql
    $this->_execute_query($common_query);
    while(ocifetchinto($this->stmt,$row,OCI_ASSOC))
    $index[]=array_change_key_case($row);

    //ͺ̽ 
    $this->_disconnect_db();

    //Ʈ  ù(2004.03.10)
    return index_chain('id','pid','ppid',$index);
  }

  //ε б(2002.03.12)
  function findfile($db,$ff,$fw)
  {
    //ӽ
    if( empty($ff)||empty($fw)) return null;

    //sql
    $common_query="select id,$ff from $db where $ff like '%$fw%'";

    $this->_connect_db();
    $this->_execute_query($common_query);
    while(ocifetchinto($this->stmt,$row,OCI_ASSOC))
    $index[$row[strtoupper($ff)]][]=$row["ID"];
    $this->_disconnect_db();

    return empty($index) ? null:$index;
  }
/************************************************************************\
[]. б,,
\************************************************************************/
  //  б
  function loaddatalist($db,$index)
  {
    $this->_connect_db();
    $list=array();

    if(count($index)>0)
    foreach($index as $no=>$row){
        $common_query="select * from $db where id=$row";

        $this->_execute_query($common_query);
        ocifetchinto($this->stmt,&$temp,OCI_ASSOC+OCI_RETURN_NULLS);
        $temp=$this->decodedheader($temp);

        $list[$row]=$temp;
    }//end foreach

    $this->_disconnect_db();

    return empty($list) ? null:$list;
  }

  //  б
  function loaddatafile($db,$id)
  {
    //ӽ
    if( empty($id) || ($id)<0 ) return null;

    $temp=$this->loaddatalist($db,array($id));

    return empty($temp) ? null:$temp[$id];
  }

  //  
  function savedatafile($data,$db,$cmd="")
  {
    $data=$this->encodedheader($data);

    //long type skip
    unset($data["content"]);
    unset($data["opinion"]);

    $update=$fields=$values=array();
    foreach ($data as $key => $val){
      $update[] = "$key=".quote($val);
      $fields[] = $key;
      $values[] = quote($val);
    }//end foreach

    $update = implode(",",$update);
    $fields = implode(",",$fields);
    $values = implode(",",$values);

    //ű߰,亯 ο ε ߰ϱ
    switch($cmd)
    {
      case 'reply':
      case 'write':
        $common_query="insert into $db ($fields) values ($values)";
        break;

      default:
        $common_query="update $db set $update where id=".($data["id"]);
        break;
    }//end switch

    $this->_connect_db();
    $this->_execute_query($common_query);
    $this->_disconnect_db();
  }

  //  
  function movedatafile($db,$id)
  {
    $common_query="delete from $db where id=$id";

    $this->_connect_db();
    $this->_execute_query($common_query);
    $this->_disconnect_db();
  }
/************************************************************************\
[]. б,
\************************************************************************/
  //  б
  function loadcontentfile($data,$db,$id)
  {
    //ӽ
    if( empty($id) || ($id)<0 ) return null;

    //blob о̱  _value ̿Ѵ.
    $common_query="select CONTENT from $db where id=$id";

    $this->_connect_db();
    $text=$this->_execute_get($common_query,"CONTENT");
    $this->_disconnect_db();

    return $text;
  }

  //  
  function savecontentfile($text,$db,$id)
  {
    $text=quote($text);

    $common_query="update $db set content=empty_clob() where id=$id ".
                  "returning content into :text";

    $this->_connect_db();
    $this->_execute_clob($common_query,$text);
    $this->_disconnect_db();
  }
/************************************************************************\
[].ǰ б,
\************************************************************************/
  //ǰ  б
  function loadopinionfile($db,$id)
  {
    //ӽ
    if( empty($id) || ($id)<0 ) return null;

    //blob о̱  _value ̿Ѵ.
    $common_query="select OPINION from $db where id=$id";

    $this->_connect_db();
    $text=$this->_execute_get($common_query,"OPINION");
    $this->_disconnect_db();

    return $text;
  }

  //ǰ  
  function saveopinionfile($text,$db,$id)
  {
    $text=quote($text);

    $common_query="update $db set opinion=empty_clob() where id=$id ".
                  "returning opinion into :text";

    $this->_connect_db();
    $this->_execute_clob($common_query,$text);
    $this->_disconnect_db();
  }
}
?>
