<?
/************************************************************************\
 * α׷ : pop3 
 * Ư   : 1.pop3(post office protocol)
 * ̺ :
 * services   :
 *      : ö
 * ۼ   : 2004/04
 *      :
 *    :
 *    :
\************************************************************************/
require_once ('inc/common.php');
require_once ('inc/mime.php');

class db_pop3 extends db_common
{
  var $db_host=null;//ȣƮ
  var $db_user=null;//
  var $db_pass=null;//ȣ
  var $db_name=null;//Ÿ̽

  var $socket=0;
  var $result=false;
  var $last_cmd,$last_msg;
  var $errno,$errstr;

  //⺻
  function db_set($defconf)
  {
    if(empty($defconf))return;
$this->timestamps("db_set");
    $this->db_host=$defconf["pop3_host"];
    $this->db_user=$defconf["pop3_user"];
    $this->db_pass=$defconf["pop3_pass"];
    $this->db_name=$defconf["pop3_name"];
  }

  //ýۿ ϱ
  function _connect()
  {
    $this->last_msg="open socket";

    if(!$this->_connected()){
$this->timestamps("_connect");

    $this->socket=fsockopen($this->db_host,port_pop3,&$this->errno,&$this->errstr,15) or die("fsockopen file open");

    $this->_command("");

    if ($this->_login($this->db_user,$this->db_pass)) unset( $this->socket );
    }//end if

    return $this->socket;
  }

  //Ȯ
  function _connected()
  {
    if($this->socket <= 0) return false;

    $sock_status=socket_get_status($this->socket);

    return empty($sock_status["eof"]);
  }

  // ϱ
  function _command($cmd)
  {
    $this->last_msg="";
    $this->last_cmd=$cmd;

    if(!$this->_connected()) return false;

    //ɾ 
    if($cmd)
    fwrite($this->socket,$cmd."\r\n");

    $this->last_msg=$this->_fetch_row();

$this->timestamps("$cmd");
    return $this->result=ereg("^(\+OK)",$this->last_msg);
  }

  function _login( $user,$pass )
  {
    if(empty($user) || empty($pass)) return false;

    $command="user " .$user;
    if( !$this->_command( $command ) ) return false;

    $command="pass " .$pass;
    if( !$this->_command( $command ) ) return false;
  }

  function _fetch_row()
  {
    $buffer=fgets($this->socket,8192);
    return preg_replace("/\r?\n/","\r\n",$buffer);
  }

  function _fetch_assoc()
  {
    if( chop( $line=$this->_fetch_row() ) == "." ) return 0;
    return $line;
  }

  //޽ ϱ
  function _error_db()
  {
    if( $this->errno ){
      $cmd=wordwrap($this->last_cmd,80,"\n",1);

      echo("<div>\n");
      echo("<table width='100%' height='100%' border='0' cellpadding='0' cellspacing='0'>\n");
      echo("<tr>\n");
      echo("<td height=40 bgcolor='red' align='center' valign='middle'>\n");
      echo("<font color='#ffffff'><b>error</b></font>\n");
      echo("</td></tr>\n");
      echo("<tr>\n");
      echo("<td bgcolor='white'>\n");
      echo("sql query : <pre>$cmd</pre><br>\n");
      echo("<p align=>$this->errstr</p>\n");
      echo("</td></tr>\n");
      echo("<tr>\n");
      echo("<td height=40 bgcolor='red' align='center' valign='middle'>\n");
      echo("</td></tr>\n");
      echo("</table>\n");
      echo("</div>\n");
      exit;
    }//endif
  }

  //
  function _disconnect()
  {
    return true;

    //send pop3 quit command
    $this->_command( "quit" );

    //close socket
    fclose($this->socket);
    unset($this->socket);
  }

  function _version_db(){}
  function create_db($db){}
  function drop_db($db){}
/************************************************************************\
[].ε б
\************************************************************************/
  //ü Ÿ б
  function loadtotal($db,$ff='',$fw='')
  {
    //sql
    $command="stat";

    //
    $this->_connect();

    //sql
    $this->_command($command);
    $msgs=split(" ",$this->last_msg);
    $total=$msgs[1];

    //
    $this->_disconnect();

    return $total;
  }

  //ü ε б
  function loadindexfile($db)
  {
    //sql
    $command="list";

    //
    $this->_connect();

    //sql
    $this->_command($command);

    while($line=$this->_fetch_assoc()){
      $msgs=split(" ",$line);
      $index[]=$msgs[0];
    }//end while

    //
    $this->_disconnect();

    if(count($index)>1)rsort($index);

    return $index;
  }

  //˻ ε б
  function findindexfile($db,$ff,$fw)
  {
    global $sysconf;

    //ӽ
    if( empty($ff)||empty($fw)) return null;

    //ã Ķ (2001.12.14)
    switch($ff)
    {
      case 'content':
      case 'all':
        break;

      default:
        $common_query="$sysconf[findall] $ff=.*$fw ".path_fix("$sysconf[path_host]/db/$db/data/*.cgi");
        break;
    }//end switch

    $rows=runshell($common_query);

    //ӽ( )
    if( empty($rows)) return null;

    //̸ ϱ
    if(is_array($rows))
    $index=array_map("extractfilename",$rows);

    return empty($index) ? null:$index;
  }

  // ε б
  function sortindexfile($db,$ff){}

  //亯 ε б(2002.03.12)
  function findreplyfile($db,$ppid){}
/************************************************************************\
[]. б,,
\************************************************************************/
  //  б
  function loaddatalist($db,$index)
  {
    global $sysconf;

    $this->_connect();
    $data=array();
    if(count($index)>0)
    foreach($index as $no=>$row){
        $command="top $row 0";

        $this->_command($command);

        $messages='';
        while($line=$this->_fetch_assoc())
        $messages.=$line;

        $mime=new mime();
        $temp=$mime->get_mail_info($messages);

        $temp["id"]=$row;//
        $temp["rowid"]=md5(trim($temp["date"].$temp["message-id"]));
        $temp["name"]=$temp["from"][0]["name"];
        $temp["email"]=$temp["from"][0]["mail"];
        $temp["in_date"]=date(shortdateformat,$temp["date"]);
        $temp["in_time"]=$temp["mo_time"]=$temp["date"];
        $temp["localname"]=path_fix("$sysconf[path_host]/db/$db/data/$temp[rowid].eml");

        $data[$row]=$temp;
    }//end foreach

    $this->_disconnect();

    return $data;
  }

  //  б
  function loaddatafile($db,$id)
  {
    //ӽ
    if( empty($id) || ($id=to_index($id)) < 0 ) return null;

    $temp=$this->loaddatalist($db,array($id));

    return empty($temp) ? null:$temp[$id];
  }

  //  
  function savedatafile($data,$db,$cmd=""){}
  //  
  function movedatafile($db,$id){}
/************************************************************************\
[]. б,
\************************************************************************/
  //  б
  function loadcontentfile(&$msg,$db,$id)
  {
    global $sysconf;

    //ӽ
    if( empty($id) || ($id=to_index($id)) < 0 ) return null;

    if(file_exists($msg["localname"])) {
        $msgcontent=file_get_contents($msg["localname"]);
    }else{
        $command="retr $id";

        $this->_connect();
        $this->_command($command);
        $msgcontent='';
        while($line=$this->_fetch_assoc())
        $msgcontent.=$line;
        $this->_disconnect();

        file_put_contents($msg["localname"],$msgcontent);
    }//end if else

    $mime=new mime();
    $mime->user_folder=path_fix("$sysconf[path_host]/db/$db/upload");
    $temp=$mime->decode($msgcontent);

    $msg["htmltype"]=$mime->use_html;
    $msg["attachfile"]=$temp["attachments"];

    return $temp["body"];
  }

  //  
  function savecontentfile($text,$db,$id){}
/************************************************************************\
[].ǰ б,
\************************************************************************/
  //ǰ  б
  function loadopinionfile($db,$id){}

  //ǰ  
  function saveopinionfile($text,$db,$id){}
}
?>
